From 19381bca6b840180b7510bc0be6c710a9ca7c9eb Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Fri, 30 Sep 2022 16:15:09 +0200
Subject: [PATCH] scss: display a minimalistic focus ring by default (#69762)

---
 static/armentieres/_vars.scss          | 1 +
 static/correze-cd19/_vars.scss         | 1 +
 static/essey-les-nancy/_vars.scss      | 1 +
 static/gpseo/_vars.scss                | 1 +
 static/grand-nancy/_vars.scss          | 1 +
 static/includes/_forms.scss            | 2 +-
 static/lanester/_vars.scss             | 1 +
 static/orleans/_vars.scss              | 1 +
 static/publik-famille-demo/_vars.scss  | 1 +
 static/sables-d-olonne-2022/_vars.scss | 1 +
 10 files changed, 10 insertions(+), 1 deletion(-)

diff --git a/static/armentieres/_vars.scss b/static/armentieres/_vars.scss
index 5db7f753..e6ad39c2 100644
--- a/static/armentieres/_vars.scss
+++ b/static/armentieres/_vars.scss
@@ -78,6 +78,7 @@ $cell-entry-font-weight: normal;
 $cell-entry-hover-background: transparent;
 $cell-entry-border: none;
 
+$widget-focus-outline: none;
 $widget-focus-box-shadow: 0 0 5px 2px $gray-light;
 
 // Footer
diff --git a/static/correze-cd19/_vars.scss b/static/correze-cd19/_vars.scss
index 65bd0014..3e5be643 100644
--- a/static/correze-cd19/_vars.scss
+++ b/static/correze-cd19/_vars.scss
@@ -17,6 +17,7 @@ $button-background: $green;
 $button-color: white;
 $widget-border: 1px solid #ced4da;
 $widget-focus-background: #f0f0f0;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: inset 2px 2px 5px 0 #c9c9c9;
 $widget-unique-checkbox-position: left;
 $title-background: $primary-color;
diff --git a/static/essey-les-nancy/_vars.scss b/static/essey-les-nancy/_vars.scss
index 9e8066ff..819d2166 100644
--- a/static/essey-les-nancy/_vars.scss
+++ b/static/essey-les-nancy/_vars.scss
@@ -25,6 +25,7 @@ $border-radius: 0px;
 $button-background: $yellow;
 $widget-border: 1px solid #ced4da;
 $widget-border-radius: .25rem;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: 0 0 0 .2rem rgba(0, 123, 255, .25);
 
 $title-background: transparent;
diff --git a/static/gpseo/_vars.scss b/static/gpseo/_vars.scss
index 60b41e47..eb119c7b 100644
--- a/static/gpseo/_vars.scss
+++ b/static/gpseo/_vars.scss
@@ -57,6 +57,7 @@ $buttons-alignment: space-between;
 $widget-focus-border: 1px solid $blue;
 $widget-background: $gray;
 $widget-border: 1px solid hsl(0, 0%, 90%);
+$widget-focus-outline: none;
 $widget-focus-box-shadow: 0px 4px 4px 0 rgba(0, 0, 0, 0.15);
 $widget-focus-color: black;
 $form-sidebar-position: right;
diff --git a/static/grand-nancy/_vars.scss b/static/grand-nancy/_vars.scss
index 280e706e..0896e55b 100644
--- a/static/grand-nancy/_vars.scss
+++ b/static/grand-nancy/_vars.scss
@@ -26,6 +26,7 @@ $button-hover-background: $red;
 $button-hover-color: white;
 $widget-border: 1px solid #ced4da;
 $widget-border-radius: .25rem;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: 0 0 0 .2rem rgba(0, 123, 255, .25);
 $title-background: transparent;
 $title-font-family: Yantramanav, arial, sans-serif;
diff --git a/static/includes/_forms.scss b/static/includes/_forms.scss
index 402e4df0..7a00b4bc 100644
--- a/static/includes/_forms.scss
+++ b/static/includes/_forms.scss
@@ -16,7 +16,7 @@ $widget-border-radius: 0 !default;
 $widget-focus-background: $widget-background !default;
 $widget-focus-border: $widget-border !default;
 $widget-focus-color: $widget-color !default;
-$widget-focus-outline: none !default;
+$widget-focus-outline: 1px dotted #333 !default;
 $widget-focus-outline-offset: 0 !default;
 $widget-box-shadow: null !default;
 $widget-padding: 0.625rem 1rem !default;
diff --git a/static/lanester/_vars.scss b/static/lanester/_vars.scss
index 1f617330..788c9c05 100644
--- a/static/lanester/_vars.scss
+++ b/static/lanester/_vars.scss
@@ -41,6 +41,7 @@ $mobile-width: 100%;
 
 $widget-border: 1px solid #ccc;
 $widget-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .075);
+$widget-focus-outline: none;
 $widget-focus-box-shadow: inset 0 1px 1px rgba(0,0,0,.075), 0 0 8px rgba(204,204,204, .8);
 $button-background: $blue;
 $nav-button-color: white;
diff --git a/static/orleans/_vars.scss b/static/orleans/_vars.scss
index 819a1897..1c20484b 100644
--- a/static/orleans/_vars.scss
+++ b/static/orleans/_vars.scss
@@ -29,4 +29,5 @@ $category-link-color: $link-color;
 $category-toggled-link-hover-color: $primary-color;
 $dashboard-badge-color: lighten($primary-color, 10%);
 $widget-focus-border: 1px solid #66afe9;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: inset 0 1px 1px rgba(0,0,0,.075), 0 0 8px rgba(102, 175, 233, .6);
diff --git a/static/publik-famille-demo/_vars.scss b/static/publik-famille-demo/_vars.scss
index 4fae4c15..384a2bc6 100644
--- a/static/publik-famille-demo/_vars.scss
+++ b/static/publik-famille-demo/_vars.scss
@@ -94,6 +94,7 @@ $widget-border: 1px solid $gray-light;
 $widget-border-radius: $border-radius;
 $widget-focus-border: 1px solid $orange;
 $widget-padding: 0.625rem 1rem !default;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: none !default;
 
 $notification_error_color: $red;
diff --git a/static/sables-d-olonne-2022/_vars.scss b/static/sables-d-olonne-2022/_vars.scss
index ff663a01..0334f390 100644
--- a/static/sables-d-olonne-2022/_vars.scss
+++ b/static/sables-d-olonne-2022/_vars.scss
@@ -67,6 +67,7 @@ $widget-color: #000;
 $widget-border-radius: 10em;
 $widget-border: 0;
 $widget-box-shadow: #ccc 1px 1px 10px;
+$widget-focus-outline: none;
 $widget-focus-box-shadow: #999 1px 1px 12px;
 $widget-custom-radio-checkbox: true;
 $widget-unique-checkbox-position: left;
-- 
2.37.2