From d85e11e31c39e7eb5cfd9ced19e30778331c9fd7 Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Tue, 4 Oct 2022 15:22:56 +0200
Subject: [PATCH 4/4] auth_fc: translation update (#69850)

---
 .../locale/fr/LC_MESSAGES/django.po           | 43 ++++++++++---------
 1 file changed, 23 insertions(+), 20 deletions(-)

diff --git a/src/authentic2/locale/fr/LC_MESSAGES/django.po b/src/authentic2/locale/fr/LC_MESSAGES/django.po
index 79e12f617..540b6efdb 100644
--- a/src/authentic2/locale/fr/LC_MESSAGES/django.po
+++ b/src/authentic2/locale/fr/LC_MESSAGES/django.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Authentic\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2022-09-29 14:40+0200\n"
+"POT-Creation-Date: 2022-10-04 15:33+0200\n"
 "PO-Revision-Date: 2022-08-30 07:38+0200\n"
 "Last-Translator: Mikaël Ates <mates@entrouvert.com>\n"
 "Language-Team: None\n"
@@ -6496,23 +6496,13 @@ msgstr "sub"
 msgid "access token"
 msgstr "jeton d’accès"
 
-#: src/authentic2_auth_fc/templates/authentic2_auth_fc/explanation.html
-#: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
-msgid "opens in new window"
-msgstr "s’ouvre dans une nouvelle fenêtre"
-
-#: src/authentic2_auth_fc/templates/authentic2_auth_fc/explanation.html
-#: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
-msgid "What is FranceConnect?"
-msgstr "Qu’est-ce que FranceConnect ?"
-
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/explanation.html
 msgid ""
 "FranceConnect is the solution proposed by the French state to secure and "
 "streamline logging in to online services."
 msgstr ""
 "FranceConnect est la solution proposée par l’État pour sécuriser et "
-"simplifier votre connexion aux services en ligne."
+"simplifier la connexion à vos services en ligne."
 
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
 msgid "Linked FranceConnect identity:"
@@ -6523,13 +6513,23 @@ msgid "Delete link"
 msgstr "Supprimer la liaison"
 
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
-msgid "Link your user account to FranceConnect"
-msgstr "Lier votre compte utilisateur à FranceConnect"
+msgid "Link your user account to FranceConnect."
+msgstr "Lier votre compte utilisateur à FranceConnect."
 
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
 msgid "Link with a FranceConnect account"
 msgstr "Se lier avec un compte FranceConnect"
 
+#: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
+#: src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
+msgid "opens in new window"
+msgstr "s’ouvre dans une nouvelle fenêtre"
+
+#: src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
+#: src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
+msgid "What is FranceConnect?"
+msgstr "Qu’est-ce que FranceConnect ?"
+
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
 msgid "Log in with FranceConnect"
 msgstr "Connectez-vous avec FranceConnect"
@@ -6563,14 +6563,17 @@ msgstr ""
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html
 msgid ""
 "On your next authentications, you will have to type in a password. Clicking "
-"the “Unlink” button here will prompt you to pick this new password. For "
-"obvious security reasons, please pick a different one than the password(s) "
-"on your FranceConnect providers."
+"the “Unlink” button here will prompt you to pick this new password. Please, "
+"mind that this password will be your local account's, not the one to the "
+"account used through FranceConnect whatsoever. It will be used when logging "
+"in to this website with your email address rather than through FranceConnect."
 msgstr ""
 "Lors de vos prochaines connexions, vous aurez à taper un mot de passe. Si "
-"vous cliquer maintenant sur le bouton « Délier », vous aurez à choisir ce "
-"nouveau mot de passe. Pour des raisons de sécurité évidentes, veuillez s’il-"
-"vous-plaît choisir un mot de passe différent de ceux de vos fournisseurs "
+"vous cliquez maintenant sur le bouton « Délier », vous aurez à choisir ce "
+"nouveau mot de passe. Attention, ce mot de passe sera celui de votre compte "
+"local et en aucun cas celui du compte que vous utilisez au travers de "
+"FranceConnect. Il vous servira uniquement sur le présent site lorsque vous "
+"vous connecterez avec votre adresse électronique plutôt que via "
 "FranceConnect."
 
 #: src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html
-- 
2.37.2